package yrpg.bamp.basedata.plugin.operate;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;


public class CustomerDetailOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        e.getFieldKeys().add("yrpg_hospitals_id");
        e.getFieldKeys().add("yrpg_crm_hospital");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        String operationKey = e.getOperationKey();
        if (!operationKey.equals("savenew")){
            return;
        }
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            String hospitalsId = dataEntity.getString("yrpg_hospitals_id");
            DynamicObject hospital = QueryServiceHelper.queryOne("yrpg_hospital", "number", new QFilter[]{
                    new QFilter("yrpg_hospital_id", QCP.equals, hospitalsId)
            });
            if (hospital==null){
                continue;
            }
            String number = hospital.getString("number");

            DynamicObject terminal = QueryServiceHelper.queryOne("yrpg_base_med_terminal", "number", new QFilter[]{
                    new QFilter("yrpg_library_code", QCP.equals, number)
            });
            if (terminal==null){
                continue;
            }
            String ternumber = terminal.getString("number");

            DynamicObject endcustomer = QueryServiceHelper.queryOne("yrpg_bd_endcustomer", "id", new QFilter[]{
                    new QFilter("yrpg_industry_id", QCP.equals, ternumber)
            });
            if (endcustomer==null){
                continue;
            }
            String id = endcustomer.getString("id");
            dataEntity.set("yrpg_crm_hospital",id);
        }
        SaveServiceHelper.save(dataEntities);
    }
}
